# ``twisted`.`trial`.`_dist`.`disttrial`.`DistTrialRunner``

class documentation

`class DistTrialRunner: (source)`

View In Hierarchy

A specialized runner for distributed trial. The runner launches a number of local worker processes which will run tests.

Method | `__init__` | Undocumented
Method | `createLocalWorkers` | Create local worker protocol instances and return them.
Method | `launchWorkerProcesses` | Spawn processes from a list of process protocols.
Method | `run` | Spawn local worker processes and load tests. After that, run them.
Method | `runUntilFailure` | Run the tests with local worker processes until they fail.
Method | `writeResults` | Write test run final outcome to result.
Method | `_driveWorker` | Drive a `LocalWorkerAMP` instance, iterating the tests and calling `run` for every one of them.
Method | `_makeResult` | Make reporter factory, and wrap it with a `DistReporter`.
Instance Variable | `_logFile` | Undocumented
Instance Variable | `_logFileObject` | Undocumented
Instance Variable | `_logFileObserver` | Undocumented
Instance Variable | `_logWarnings` | Undocumented
Instance Variable | `_reporterFactory` | the reporter class to be used.
Instance Variable | `_result` | Undocumented
Instance Variable | `_rterrors` | Undocumented
Instance Variable | `_stream` | stream which the reporter will use.
Instance Variable | `_tbformat` | Undocumented
Instance Variable | `_uncleanWarnings` | Undocumented
Instance Variable | `_workerArguments` | Undocumented
Instance Variable | `_workerNumber` | the number of workers to be spawned.
Instance Variable | `_workingDirectory` | Undocumented

def __init__(self, reporterFactory, workerNumber, workerArguments, stream=None, tracebackFormat='default', realTimeErrors=False, uncleanWarnings=False, logfile='test.log', workingDirectory='_trial_temp'): (source)

Undocumented

def createLocalWorkers(self, protocols, workingDirectory): (source)
Create local worker protocol instances and return them.

Parameters
protocols | An iterable of `LocalWorkerAMP` instances.
workingDirectory:`str` | The base path in which we should run the workers.
Returns
A list of `quantity` `LocalWorker` instances.

def launchWorkerProcesses(self, spawner, protocols, arguments): (source)
Spawn processes from a list of process protocols.

Parameters
spawner | A `IReactorProcess.spawnProcess` implementation.
protocols | An iterable of `ProcessProtocol` instances.
arguments | Extra arguments passed to the processes.

def run(self, suite, reactor=None, cooperate=cooperate, untilFailure=False): (source)
Spawn local worker processes and load tests. After that, run them.

Parameters
suite | A tests suite to be run.
reactor:A provider of `twisted.internet.interfaces.IReactorProcess` | The reactor to use, to be customized in tests.
cooperate:`function` | The cooperate function to use, to be customized in tests.
untilFailure:`bool`. | If `True`, continue to run the tests until they fail.
Returns
`DistReporter` | The test result.

def runUntilFailure(self, suite): (source)
Run the tests with local worker processes until they fail.

Parameters
suite | A tests suite to be run.

def writeResults(self, result): (source)
Write test run final outcome to result.

Parameters
result | A `TestResult` which will print errors and the summary.

def _driveWorker(self, worker, result, testCases, cooperate): (source)
Drive a `LocalWorkerAMP` instance, iterating the tests and calling `run` for every one of them.

Parameters
worker | The `LocalWorkerAMP` to drive.
result | The global `DistReporter` instance.
testCases | The global list of tests to iterate.
cooperate:`function` | The cooperate function to use, to be customized in tests.
Returns
A `Deferred` firing when all the tests are finished.

def _makeResult(self): (source)
Make reporter factory, and wrap it with a `DistReporter`.
_logFile = (source)

Undocumented

_logFileObject = (source)

Undocumented

_logFileObserver = (source)

Undocumented

_logWarnings: `bool` = (source)

Undocumented

_reporterFactory = (source)
the reporter class to be used.
_result = (source)

Undocumented

_rterrors = (source)

Undocumented

_stream = (source)
stream which the reporter will use.
_tbformat = (source)

Undocumented

_uncleanWarnings = (source)

Undocumented

_workerArguments = (source)

Undocumented

_workerNumber: `int` = (source)
the number of workers to be spawned.
_workingDirectory = (source)

Undocumented